/*
 *  debug.c
 *
 *  MyQQ debugger.
 *
 *  Copyright (C) 2008  Huang Guan
 *
 *  2008-01-31 Created.
 *
 */

#include <stdarg.h>
#include "debug.h"

void print_error(char* file, char* function, int line, const char *fmt, ...)
{
	va_list args;
	char printbuf[256];
	int i;
	va_start(args, fmt);
	i=vsprintf( printbuf, fmt, args );
	va_end(args);
	fprintf(stderr, "[%s]%s(%d): %s\n", file, function, line, printbuf);
}

static char *hex_str(unsigned char *buf,int len)
{

	const char *set = "0123456789abcdef";
	static char str[1024],*tmp;
	unsigned char *end;
	if (len > 512)
	len = 512;
	end = buf + len;
	tmp = &str[0];
	while (buf < end)
	{
          *tmp++ = set[ (*buf) >> 4 ];
          *tmp++ = set[ (*buf) & 0xF ];
          buf ++;
	}
	*tmp = '\0';
	return str;
}

void hex_dump( unsigned char * buf, int len )
{
	fprintf( stderr, hex_str( buf, len ) );
}
