/*
 *  init.c
 *
 *  Initialize the data.
 *
 *  Copyright (C) 2008  Huang Guan
 *
 *  2008-02-05 Created.
 *
 *  Description: This file mainly includes the functions about 
 *               Data Initializaion
 *               Data Cleanup
 *               
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "myqq.h"
#include "mysocket.h"
#include "protocol.h"
#include "packet.h"
#include "debug.h"

//return a qid
EXPORT int myqq_init()
{
	myqq_info_t *q = (myqq_info_t*) malloc( sizeof(myqq_info_t) );
	if( q == NULL ){
		DBG("Error allocating memory.");
		return 0;
	}
	memset( q, 0, sizeof( myqq_info_t ) );
	packet_list_init( (int)q );
	q->version = 0x1b0e;
	pthread_mutex_init( &q->buddy_mutex, NULL );
	pthread_mutex_init( &q->group_mutex, NULL );
	return (int)q;
}

EXPORT void myqq_cleanup( int qid )
{
	if( MYQQ(qid).status == ST_ONLINE )
		myqq_logout( qid );
	
}
