#ifndef _MYQQ_H
#define _MYQQ_H

#include <sys/types.h>
#include <pthread.h>

#define MYQQLIB

#include "myqqdef.h"
#include "rlist.h"
#include "packet.h"

//group member structure
typedef struct myqq_group_member_s{
	uint		uid;
	char		nick[MAX_NAME_LEN];
	char		status;
	char		role;
	char		org;
	char		sex;
	ushort		face;
	char		qqshow;
	char		flag;
	char		age;
}myqq_group_member_t;

//group structure
typedef struct myqq_group_s{
	uint		ext_uid;
	uint		int_uid;
	char		type;
	char		name[MAX_NAME_LEN];
	char		auth_type;
	ushort		max_members;
	uint		mgr_uid;
	char		notice[GROUP_NOTICE_LEN];
	char		desc[GROUP_DESC_LEN];
	uint		category;
	ushort		member_count;
	myqq_group_member_t	member_list[MAX_GROUP_MEMBER];
	pthread_mutex_t	member_mutex;
}myqq_group_t;

//buddy structure
typedef struct myqq_buddy_s{
	uint		uid;
	char		mode;
	uint		ip;
	uint		port;
	int		sock_im;	//socket for chating
	//This may eat a large block of memory, especailly you have lots of buddies.
	char		info[MAX_BUDDY_INFO][BUDDY_INFO_LEN];
	ushort		face;
	char		age;
	char		sex;
	char		qqshow;
			/* qqshow: (0-7)
			 *        bit1 => qq show */
	char		flag;
			/*
			 * flag: (0-7)
			 *        bit1 => member
			 *        bit4 => TCP mode
			 *        bit5 => open mobile QQ
			 *        bit6 => bind to mobile
			 *        bit7 => whether having a video
			 */
	char		nick[MAX_NAME_LEN];
	char		session_key[16];
}myqq_buddy_t;


typedef struct myqq_info_s{
	uint		uid;
	char		password[MAX_PASSWORD];
	ushort		version;
	int		mode;		//login mode
	int		seqno;		//sequence number
	int		token_len;	//token size: 24
	char		token[32];	//
	char		login_key[16];
	char		session_key[16];
	char		session_md5[16];	//uid+session_key, md5.
	int		sock_im;	//socket for chating
	char		pass_encrypted[16];
	uint		server_ip;
	ushort		server_port;
	uint		client_ip;
	ushort		client_port;
	uint		last_client_ip;
	time_t		login_time;
	time_t		last_login_time;
	int		status;	//ST_OFFLINE   ST_ONLINE   ST_ERROR   ST_WRPASS   ST_REDIRECT
	pthread_t	thread_recv;	//a thread for receiving packets
	int		buddy_count;
	pthread_mutex_t	buddy_mutex;	//for buddy_list modifying
	myqq_buddy_t*	buddy_list[MAX_BUDDY];
	pthread_t	thread_alive;
	int		buddy_online_count;
	int		group_count;
	myqq_group_t* group_list[MAX_GROUP];
	pthread_mutex_t	group_mutex;
	messenger buddy_msgr;
	newstatus status_msgr;
	group_messenger group_msgr;
	myqq_packet_list_t	plist;
	myqq_rlist_t		rlist;	//used for checking the packet whether we've already 
					//have it.
}myqq_info_t;

//from qid to MYQQ(qid)
#define MYQQ(qid) (*(myqq_info_t*)qid)

#endif //_MYQQ_H
